pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT > Class Template Reference
Module sample_consensus

SampleConsensusModelNormalParallelPlane defines a model for 3D plane segmentation using additional surface normal constraints. More...

`#include <pcl/sample_consensus/sac_model_normal_parallel_plane.h>`

Inheritance diagram for pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >:

## Public Types

typedef SampleConsensusModel< PointT >::PointCloud | PointCloud
typedef SampleConsensusModel< PointT >::PointCloudPtr | PointCloudPtr
typedef SampleConsensusModel< PointT >::PointCloudConstPtr | PointCloudConstPtr
typedef SampleConsensusModelFromNormals< PointT, PointNT >::PointCloudNPtr | PointCloudNPtr
typedef SampleConsensusModelFromNormals< PointT, PointNT >::PointCloudNConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< SampleConsensusModelNormalParallelPlane > | Ptr
Public Types inherited from pcl::SampleConsensusModelNormalPlane< PointT, PointNT >
typedef SampleConsensusModel< PointT >::PointCloud | PointCloud
typedef SampleConsensusModel< PointT >::PointCloudPtr | PointCloudPtr
typedef SampleConsensusModel< PointT >::PointCloudConstPtr | PointCloudConstPtr
typedef SampleConsensusModelFromNormals< PointT, PointNT >::PointCloudNPtr | PointCloudNPtr
typedef SampleConsensusModelFromNormals< PointT, PointNT >::PointCloudNConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< SampleConsensusModelNormalPlane > | Ptr
Public Types inherited from pcl::SampleConsensusModelPlane< PointT >
typedef SampleConsensusModel< PointT >::PointCloud | PointCloud
typedef SampleConsensusModel< PointT >::PointCloudPtr | PointCloudPtr
typedef SampleConsensusModel< PointT >::PointCloudConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< SampleConsensusModelPlane > | Ptr
Public Types inherited from pcl::SampleConsensusModel< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef pcl::PointCloud< PointT >::ConstPtr | PointCloudConstPtr
typedef pcl::PointCloud< PointT >::Ptr | PointCloudPtr
typedef pcl::search::Search< PointT >::Ptr | SearchPtr
typedef boost::shared_ptr< SampleConsensusModel > | Ptr
typedef boost::shared_ptr< const SampleConsensusModel > | ConstPtr
Public Types inherited from pcl::SampleConsensusModelFromNormals< PointT, PointNT >
typedef pcl::PointCloud< PointNT >::ConstPtr | PointCloudNConstPtr
typedef pcl::PointCloud< PointNT >::Ptr | PointCloudNPtr
typedef boost::shared_ptr< SampleConsensusModelFromNormals > | Ptr
typedef boost::shared_ptr< const SampleConsensusModelFromNormals > | ConstPtr

## Public Member Functions

| SampleConsensusModelNormalParallelPlane (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelNormalParallelPlane. More...
| SampleConsensusModelNormalParallelPlane (const PointCloudConstPtr &cloud, const std::vector< int > &indices, bool random=false)
| Constructor for base SampleConsensusModelNormalParallelPlane. More...
virtual | ~SampleConsensusModelNormalParallelPlane ()
| Empty destructor. More...
void | setAxis (const Eigen::Vector3f &ax)
| Set the axis along which we need to search for a plane perpendicular to. More...
Eigen::Vector3f | getAxis ()
| Get the axis along which we need to search for a plane perpendicular to. More...
void | setEpsAngle (const double ea)
| Set the angle epsilon (delta) threshold. More...
double | getEpsAngle ()
| Get the angle epsilon (delta) threshold. More...
void | setDistanceFromOrigin (const double d)
| Set the distance we expect the plane to be from the origin. More...
double | getDistanceFromOrigin ()
| Get the distance of the plane from the origin. More...
void | setEpsDist (const double delta)
| Set the distance epsilon (delta) threshold. More...
double | getEpsDist ()
| Get the distance epsilon (delta) threshold. More...
pcl::SacModel | getModelType () const
| Return an unique id for this model (SACMODEL_NORMAL_PARALLEL_PLANE). More...
Public Member Functions inherited from pcl::SampleConsensusModelNormalPlane< PointT, PointNT >
| SampleConsensusModelNormalPlane (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelNormalPlane. More...
| SampleConsensusModelNormalPlane (const PointCloudConstPtr &cloud, const std::vector< int > &indices, bool random=false)
| Constructor for base SampleConsensusModelNormalPlane. More...
virtual | ~SampleConsensusModelNormalPlane ()
| Empty destructor. More...
void | selectWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold, std::vector< int > &inliers)
| Select all the points which respect the given model coefficients as inliers. More...
virtual int | countWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold)
| Count all the points which respect the given model coefficients as inliers. More...
void | getDistancesToModel (const Eigen::VectorXf &model_coefficients, std::vector< double > &distances)
| Compute all distances from the cloud data to a given plane model. More...
pcl::SacModel | getModelType () const
| Return an unique id for this model (SACMODEL_NORMAL_PLANE). More...
Public Member Functions inherited from pcl::SampleConsensusModelPlane< PointT >
| SampleConsensusModelPlane (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelPlane. More...
| SampleConsensusModelPlane (const PointCloudConstPtr &cloud, const std::vector< int > &indices, bool random=false)
| Constructor for base SampleConsensusModelPlane. More...
virtual | ~SampleConsensusModelPlane ()
| Empty destructor. More...
bool | computeModelCoefficients (const std::vector< int > &samples, Eigen::VectorXf &model_coefficients)
| Check whether the given index samples can form a valid plane model, compute the model coefficients from these samples and store them internally in model_coefficients_. More...
void | getDistancesToModel (const Eigen::VectorXf &model_coefficients, std::vector< double > &distances)
| Compute all distances from the cloud data to a given plane model. More...
void | selectWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold, std::vector< int > &inliers)
| Select all the points which respect the given model coefficients as inliers. More...
void | optimizeModelCoefficients (const std::vector< int > &inliers, const Eigen::VectorXf &model_coefficients, Eigen::VectorXf &optimized_coefficients)
| Recompute the plane coefficients using the given inlier set and return them to the user. More...
void | projectPoints (const std::vector< int > &inliers, const Eigen::VectorXf &model_coefficients, PointCloud &projected_points, bool copy_data_fields=true)
| Create a new point cloud with inliers projected onto the plane model. More...
bool | doSamplesVerifyModel (const std::set< int > &indices, const Eigen::VectorXf &model_coefficients, const double threshold)
| Verify whether a subset of indices verifies the given plane model coefficients. More...
pcl::SacModel | getModelType () const
| Return an unique id for this model (SACMODEL_PLANE). More...
Public Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModel. More...
| SampleConsensusModel (const PointCloudConstPtr &cloud, const std::vector< int > &indices, bool random=false)
| Constructor for base SampleConsensusModel. More...
virtual | ~SampleConsensusModel ()
| Destructor for base SampleConsensusModel. More...
virtual void | getSamples (int &iterations, std::vector< int > &samples)
| Get a set of random data samples and return them as point indices. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const boost::shared_ptr< std::vector< int > > &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const std::vector< int > &indices)
| Provide the vector of indices that represents the input data. More...
boost::shared_ptr< std::vector< int > > | getIndices () const
| Get a pointer to the vector of indices used. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
unsigned int | getSampleSize () const
| Return the size of a sample from which the model is computed. More...
unsigned int | getModelSize () const
| Return the number of coefficients in the model. More...
void | setRadiusLimits (const double &min_radius, const double &max_radius)
| Set the minimum and maximum allowable radius limits for the model (applicable to models that estimate a radius) More...
void | getRadiusLimits (double &min_radius, double &max_radius)
| Get the minimum and maximum allowable radius limits for the model as set by the user. More...
void | setSamplesMaxDist (const double &radius, SearchPtr search)
| Set the maximum distance allowed when drawing random samples. More...
void | getSamplesMaxDist (double &radius)
| Get maximum distance allowed when drawing random samples. More...
double | computeVariance (const std::vector< double > &error_sqr_dists)
| Compute the variance of the errors to the model. More...
double | computeVariance ()
| Compute the variance of the errors to the model from the internally estimated vector of distances. More...
Public Member Functions inherited from pcl::SampleConsensusModelFromNormals< PointT, PointNT >
| SampleConsensusModelFromNormals ()
| Empty constructor for base SampleConsensusModelFromNormals. More...
virtual | ~SampleConsensusModelFromNormals ()
| Destructor. More...
void | setNormalDistanceWeight (const double w)
| Set the normal angular distance weight. More...
double | getNormalDistanceWeight ()
| Get the normal angular distance weight. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals ()
| Get a pointer to the normals of the input XYZ point cloud dataset. More...

## Protected Member Functions

virtual bool | isModelValid (const Eigen::VectorXf &model_coefficients)
| Check whether a model is valid given the user constraints. More...
Protected Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (bool random=false)
| Empty constructor for base SampleConsensusModel. More...
void | drawIndexSample (std::vector< int > &sample)
| Fills a sample array with random samples from the indices_ vector. More...
void | drawIndexSampleRadius (std::vector< int > &sample)
| Fills a sample array with one random sample from the indices_ vector and other random samples that are closer than samples_radius_. More...
int | rnd ()
| Boost-based random number generator. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
std::string | model_name_
| The model name. More...
PointCloudConstPtr | input_
| A boost shared pointer to the point cloud data array. More...
boost::shared_ptr< std::vector< int > > | indices_
| A pointer to the vector of point indices to use. More...
double | radius_min_
| The minimum and maximum radius limits for the model. More...
double | radius_max_
double | samples_radius_
| The maximum distance of subsequent samples from the first (radius search) More...
SearchPtr | samples_radius_search_
| The search object for picking subsequent samples using radius search. More...
std::vector< int > | shuffled_indices_
| Data containing a shuffled version of the indices. More...
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm. More...
boost::shared_ptr< boost::uniform_int<> > | rng_dist_
| Boost-based random number generator distribution. More...
boost::shared_ptr< boost::variate_generator< boost::mt19937 &, boost::uniform_int<> > > | rng_gen_
| Boost-based random number generator. More...
std::vector< double > | error_sqr_dists_
| A vector holding the distances to the computed model. More...
unsigned int | sample_size_
| The size of a sample from which the model is computed. More...
unsigned int | model_size_
| The number of coefficients in the model. More...
Protected Attributes inherited from pcl::SampleConsensusModelFromNormals< PointT, PointNT >
double | normal_distance_weight_
| The relative weight (between 0 and 1) to give to the angular distance (0 to pi/2) between point normals and the plane normal. More...
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Static Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
static const unsigned int | max_sample_checks_ = 1000
| The maximum number of samples to try until we get a good one. More...

## Detailed Description

### template<typename PointT, typename PointNT>
class pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >

SampleConsensusModelNormalParallelPlane defines a model for 3D plane segmentation using additional surface normal constraints.

Basically this means that checking for inliers will not only involve a "distance to model" criterion, but also an additional "maximum angular deviation" between the plane's normal and the inlier points normals. In addition, the plane normal must lie parallel to an user-specified axis.

The model coefficients are defined as:

- a : the X coordinate of the plane's normal (normalized)
- b : the Y coordinate of the plane's normal (normalized)
- c : the Z coordinate of the plane's normal (normalized)
- d : the fourth Hessian component of the plane's equation

To set the influence of the surface normals in the inlier estimation process, set the normal weight (0.0-1.0), e.g.:

SampleConsensusModelNormalPlane<pcl::PointXYZ, pcl::Normal> sac_model;
...
sac_model.setNormalDistanceWeight (0.1);
...

In addition, the user can specify more constraints, such as:

- an axis along which we need to search for a plane perpendicular to (setAxis);
- an angle tolerance threshold between the plane's normal and the above given axis (setEpsAngle);
- a distance we expect the plane to be from the origin (setDistanceFromOrigin);
- a distance tolerance as the maximum allowed deviation from the above given distance from the origin (setEpsDist).

Note
  Please remember that you need to specify an angle > 0 in order to activate the axis-angle constraint!

Author
  Radu B. Rusu and Jared Glover and Nico Blodow

Definition at line 84 of file sac_model_normal_parallel_plane.h.

## Member Typedef Documentation

## PointCloud

template<typename PointT, typename PointNT>

typedef SampleConsensusModel<PointT>::PointCloud pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloud

Definition at line 94 of file sac_model_normal_parallel_plane.h.

## PointCloudConstPtr

template<typename PointT, typename PointNT>

typedef SampleConsensusModel<PointT>::PointCloudConstPtr pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloudConstPtr

Definition at line 96 of file sac_model_normal_parallel_plane.h.

## PointCloudNConstPtr

template<typename PointT, typename PointNT>

typedef SampleConsensusModelFromNormals<PointT, PointNT>::PointCloudNConstPtr pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloudNConstPtr

Definition at line 99 of file sac_model_normal_parallel_plane.h.

## PointCloudNPtr

template<typename PointT, typename PointNT>

typedef SampleConsensusModelFromNormals<PointT, PointNT>::PointCloudNPtr pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloudNPtr

Definition at line 98 of file sac_model_normal_parallel_plane.h.

## PointCloudPtr

template<typename PointT, typename PointNT>

typedef SampleConsensusModel<PointT>::PointCloudPtr pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloudPtr

Definition at line 95 of file sac_model_normal_parallel_plane.h.

## Ptr

template<typename PointT, typename PointNT>

typedef boost::shared_ptr<SampleConsensusModelNormalParallelPlane> pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::Ptr

Definition at line 101 of file sac_model_normal_parallel_plane.h.

## Constructor & Destructor Documentation

## SampleConsensusModelNormalParallelPlane() [1/2]

template<typename PointT, typename PointNT>

pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::SampleConsensusModelNormalParallelPlane | ( | const PointCloudConstPtr & | cloud,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelNormalParallelPlane.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 107 of file sac_model_normal_parallel_plane.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, and pcl::SampleConsensusModel< PointT >::sample_size_.

## SampleConsensusModelNormalParallelPlane() [2/2]

template<typename PointT, typename PointNT>

pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::SampleConsensusModelNormalParallelPlane | ( | const PointCloudConstPtr & | cloud,
|  | const std::vector< int > & | indices,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelNormalParallelPlane.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | indices | a vector of point indices to be used from cloud
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 126 of file sac_model_normal_parallel_plane.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, and pcl::SampleConsensusModel< PointT >::sample_size_.

## ~SampleConsensusModelNormalParallelPlane()

template<typename PointT, typename PointNT>

virtual pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::~SampleConsensusModelNormalParallelPlane | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 142 of file sac_model_normal_parallel_plane.h.

## Member Function Documentation

## getAxis()

template<typename PointT, typename PointNT>

Eigen::Vector3f pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getAxis | ( |  | ) |

inline

Get the axis along which we need to search for a plane perpendicular to.

Definition at line 152 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## getDistanceFromOrigin()

template<typename PointT, typename PointNT>

double pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getDistanceFromOrigin | ( |  | ) |

inline

Get the distance of the plane from the origin.

Definition at line 173 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## getEpsAngle()

template<typename PointT, typename PointNT>

double pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getEpsAngle | ( |  | ) |

inline

Get the angle epsilon (delta) threshold.

Definition at line 163 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## getEpsDist()

template<typename PointT, typename PointNT>

double pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getEpsDist | ( |  | ) |

inline

Get the distance epsilon (delta) threshold.

Definition at line 183 of file sac_model_normal_parallel_plane.h.

## getModelType()

template<typename PointT, typename PointNT>

pcl::SacModel pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getModelType | ( |  | ) | const

inline virtual

Return an unique id for this model (SACMODEL_NORMAL_PARALLEL_PLANE).

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 187 of file sac_model_normal_parallel_plane.h.

References pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::isModelValid(), and pcl::SACMODEL_NORMAL_PARALLEL_PLANE.

## isModelValid()

template<typename PointT , typename PointNT >

bool pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::isModelValid | ( | const Eigen::VectorXf & | model_coefficients | ) |

protected virtual

Check whether a model is valid given the user constraints.

Parameters

  [in] | model_coefficients | the set of model coefficients

Reimplemented from pcl::SampleConsensusModel< PointT >.

Definition at line 48 of file sac_model_normal_parallel_plane.hpp.

Referenced by pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getModelType().

## setAxis()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::setAxis | ( | const Eigen::Vector3f & | ax | ) |

inline

Set the axis along which we need to search for a plane perpendicular to.

Parameters

  [in] | ax | the axis along which we need to search for a plane perpendicular to

Definition at line 148 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## setDistanceFromOrigin()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::setDistanceFromOrigin | ( | const double | d | ) |

inline

Set the distance we expect the plane to be from the origin.

Parameters

  [in] | d | distance from the template plane to the origin

Definition at line 169 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## setEpsAngle()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::setEpsAngle | ( | const double | ea | ) |

inline

Set the angle epsilon (delta) threshold.

Parameters

  [in] | ea | the maximum allowed deviation from 90 degrees between the plane normal and the given axis.

Note
  You need to specify an angle > 0 in order to activate the axis-angle constraint!

Definition at line 159 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## setEpsDist()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::setEpsDist | ( | const double | delta | ) |

inline

Set the distance epsilon (delta) threshold.

Parameters

  [in] | delta | the maximum allowed deviation from the template distance from the origin

Definition at line 179 of file sac_model_normal_parallel_plane.h.

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/sample_consensus/include/pcl/sample_consensus/sac_model_normal_parallel_plane.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/sample_consensus/include/pcl/sample_consensus/impl/sac_model_normal_parallel_plane.hpp